<template>
  <div class="vlue-dev-sidebar-property-field">
    <label v-if="!Object.keys({ ...this.imageSelectParams, ...this.fontSelectParams}).length">
      {{prop.name}}
    </label>
    <!-- align -->
    <div class="vlue-dev-sidebar-button-row"
      v-if="(prop.type == 'align')">
      <input class="vlue-dev-sidebar-button"
        type="button"
        v-for="align in ['row', 'column', 'grid']"
        :class="{ selected : prop.value == align }"
        :disabled="!prop.value"
        :value="{ 'row': '..', 'column': ':', 'grid': '::' }[align]"
        v-on:click="interaction(align)">
    </div>
    <!-- textarea -->
    <textarea class="vlue-dev-sidebar-text-area"
      v-else-if="(prop.type == 'textarea')"
      rows="5"
      v-on:input="interaction($event.target.value)"
      :placeholder="prop.name"
      :value="prop.value">
    </textarea>
    <!-- textfield -->
    <input class="vlue-dev-sidebar-text-field"
      v-else-if="(prop.type == 'textfield')"
      type="text"
      v-on:change="interaction($event.target.value)"
      :placeholder="prop.name"
      :value="prop.value">
    <!-- image -->
    <input class="vlue-dev-sidebar-button vlue-dev-sidebar-image-select-button"
      v-else-if="(prop.type == 'image')"
      type="button"
      v-on:click="interaction(prop.value)"
      :style="{ 'background-image' : (prop.value ? 'url(' + prop.value + ')' : undefined) }"
      value="">
    <!-- font -->
    <input class="vlue-dev-sidebar-button vlue-dev-sidebar-font-select-button"
      v-else-if="(prop.type == 'font')"
      type="button"
      v-on:click="interaction(prop.value)"
      :style="{ 'font-family' : prop.value ? prop.value.split('.')[0] : undefined }"
      :value="prop.value ? 'Once upon a time in a world far away from home' : undefined">
    <!-- dropdown -->
    <div class="vlue-dev-sidebar-dropdown"
      v-else-if="(prop.type == 'dropdown')"
      :class="{ expanded }">
      <input class="vlue-dev-sidebar-button vlue-dev-sidebar-dropdown-select"
        type="button"
        v-on:click="interaction()"
        :value="prop.value">
      <div class="vlue-dev-sidebar-dropdown-options"
        v-if="expanded">
        <input class="vlue-dev-sidebar-button"
          v-for="option in prop.options"
          type="button"
          v-on:click="interaction(option)"
          :value="option">
      </div>
    </div>
    <!-- flag -->
    <button class="vlue-dev-sidebar-button vlue-dev-sidebar-checkbox"
      :class="{ toggled: prop.value }"
      v-on:click="interaction(prop.value ? '' : true)"
      v-else-if="(prop.type == 'flag')">
      <div class="vlue-dev-sidebar-checkbox-toggle"></div>
    </button>
    <!-- color -->
    <div class="vlue-dev-sidebar-color"
      v-else-if="(prop.type == 'color')"
      :style="{ background : prop.value }">
      <!-- hue -->
      <input type="range" min="0" max="360" :value="getColorPropertyValue(prop.value, 'h')"
        v-on:input="updateColor($event.target.value, 'h')" step="1">
      <!-- saturation -->
      <input type="range" min="0" max="100" :value="getColorPropertyValue(prop.value, 's')"
        v-on:input="updateColor($event.target.value, 's')" step="1">
      <!-- lightness -->
      <input type="range" min="0" max="100" :value="getColorPropertyValue(prop.value, 'l')"
        v-on:input="updateColor($event.target.value, 'l')" step="1">
      <!-- alpha -->
      <input type="range" min="0" max="1"   :value="getColorPropertyValue(prop.value, 'a')"
        v-on:input="updateColor($event.target.value, 'a')" step="0.1">
      <!-- color text field -->
      <input class="vlue-dev-sidebar-text-field"
        type="text"
        v-on:change="interaction($event.target.value)"
        :placeholder="prop.name"
        :value="prop.value">
    </div>
  </div>
</template>

<script lang="ts">
import Vue from 'vue'
import store from '../../store/store'
import { mapState } from 'vuex'

export default Vue.extend({
  computed: {
    ...mapState([
      'imageSelectParams',
      'fontSelectParams',
    ])
  },
  data() {
    return {
      expanded: false,
    }
  },
  props: {
    prop: Object,
    current: Object,
    required: Boolean,
    global: Object,
  },
  methods: {
    getColorPropertyValue(color, property) {
      // if color is not hsla, set to default hsla value
      if (!color?.includes('hsla')) color = 'hsla(180,50%,50%,1)'
      // extract hsla values out of string
      let hsla = {
        h: color.split('(')[1].split(',')[0],
        s: color.split(',')[1].split('%')[0],
        l: color.split(',')[2].split('%')[0],
        a: color.split(',')[3].split(')')[0],
      };
      // return chosen hsla value
      return hsla[property];
    },
    updateColor(value, property) {
      // set new color based on existing color but with new value for one property
      let newColor = 'hsla('
        + (property == 'h' ? value : this.getColorPropertyValue(this.prop.value, 'h')) + ','
        + (property == 's' ? value : this.getColorPropertyValue(this.prop.value, 's')) + '%,'
        + (property == 'l' ? value : this.getColorPropertyValue(this.prop.value, 'l')) + '%,'
        + (property == 'a' ? value : this.getColorPropertyValue(this.prop.value, 'a')) + ')';
      // update property value
      store.dispatch('changeWebsiteState', {
        mutation: 'setProperty',
        params: {
          current: this.current,
          property: this.prop,
          value: newColor,
          global: this.global,
        },
      });
    },
    interaction(value) {
      // toggle dropdown menu
      if (this.prop.type == 'dropdown') this.expanded = !this.expanded;
      // take different actions depending on context
      if ((value != undefined || ('flag image font').includes(this.prop.type))
      && (!this.required || value.trim().length)) {
        // check if clicking on an image prop while not in image select menu
        if (this.prop.type == 'image' && !Object.keys(this.imageSelectParams).length) {
          // show image select menu
          store.commit('showImageSelect', {
            current: this.current,
            property: this.prop,
            global: this.global,
          });
        // check if clicking on a font prop while not in font select menu
        } else if (this.prop.type == 'font' && !Object.keys(this.fontSelectParams).length) {
          // show font select menu
          store.commit('showFontSelect', {
            current: this.current,
            property: this.prop,
            global: this.global,
          });
        } else {
          // update property value
          store.dispatch('changeWebsiteState', {
            mutation: 'setProperty',
            params: {
              current: this.current,
              property: this.prop,
              value,
              global: this.global,
            },
          });
        }
      }
    },
  }
})
</script>

<style lang="scss">
@import "../../style/vars.scss";

label {
  color: white;
  margin: 5px 10px;
  display: block;
  font-size: 10px;
}
.vlue-dev-sidebar-property-field .vlue-dev-sidebar-dropdown {
  padding: 0;
  position: relative;
  font-size: 0;
  &:before {
    content: "";
    position: absolute;
    pointer-events: none;
    border: solid transparent 5px;
    border-top-color: white;
    right: 15px;
    top: 15px;
  }
  &.expanded:before {
    border-top-color: transparent;
    border-bottom-color: white;
    top: 10px;
  }
  .vlue-dev-sidebar-dropdown-select {
    background: none;
  }
  .vlue-dev-sidebar-button {
    width: 100%;
    margin: 0;
    border-radius: 0;
  }
}
.vlue-dev-sidebar-checkbox {
  padding: 0;
  position: relative;
  height: 35px;
  &.toggled {
    .vlue-dev-sidebar-checkbox-toggle {
      left: 50%;
      right: 5px;
      background: white;
    }
  }
  &:not(.toggled) {
    .vlue-dev-sidebar-checkbox-toggle {
      right: 50%;
      left: 5px;
      background: #0005;
    }
  }
  .vlue-dev-sidebar-checkbox-toggle {
    position: absolute;
    top: 5px;
    bottom: 5px;
    border-radius: 5px;
    transition: $vlue-transition-duration;
  }
}
.vlue-dev-sidebar-property-field .vlue-dev-sidebar-color {
  padding: 0;
  font-size: 0;
  box-shadow: inset 0 10px 10px rgba(0, 0, 0, 0.2);
  position: relative;
  input[type="range"] {
    width: 100%;
    appearance: none;
    height: 30px;
    box-sizing: border-box;
    padding: 10px;
    background: transparent;
    border-radius: 0;
    transition: $vlue-transition-duration;
    &:hover {
      background: #0002;
    }
  }
  input[type="text"] {
    margin: 0;
    padding: 10px;
    width: 100%;
    border-radius: 0;
  }
}
</style>
